<?php
namespace Planejamento\Entities;

class Prevreti extends Base\Prevreti
{

	
	public static function retornaProxNumeroNrprprevreti($filial, $servico, $data, $id, $nrorg){
		$obj = self::getObjectByWhere(
			'CDFILIAL = ? AND CDSERVFILI = ? AND DTPREVRETI > ? AND IDPREVRETI = ? AND NRORG = ?',
			array($filial, $servico, $data, $id, $nrorg),
			'NRPRPREVRETI DESC'
		);
		
		if ($obj instanceof Prevreti) {
			$numero = $obj->getNrprprevreti();
			return ++$numero;
		} else {
			return 1;
		}
	}
	
	
	public function inserePrevReti(
    	$nrorg, $filial, $servico, $data, $requisicao, $id, $dtLimit, $hrLimit,
    	$tpPrato, $prato, $filiAux, $produto, $qtd, $numero, $operador, $dtAtual
    ){
		$this->setNrorg($nrorg);
		$this->setCdfilial($filial);
		$this->setCdservfili($servico);
		$this->setDtprevreti($data);
		$this->setNrrequextr($requisicao);
		$this->setIdprevreti($id);
		$this->setDtlimitereti($dtLimit);
		$this->setHrlimitereti($hrLimit);
		$this->setCdtipoprat($tpPrato);
		$this->setCdprato($prato);
		$this->setCdfilauxprat($filiAux);
		$this->setCdproduto($produto);
		$this->setQtprevreti($qtd);
		$this->setNrprprevreti($numero);
		$this->setIdprevtpprat('S');
		
		
		$this->setCdoperador($operador);
		$this->setDtinclusao($dtAtual);
		
		$this->persist();
	}

    public function novoRegistroPrevreti(
        $nrorg, $cdfilial, $cdservfili, $dtprevreti, $cdtipoprat, $cdprato,
        $cdfilauxprat, $idprevtpprat, $idprevreti, $nrrequextr, $nrprprevreti,
        $cdproduto, $dtlimitereti, $hrlimitereti, $qtprevreti, $qtprerett1,
        $qtprerett2, $qtprerett3, $qtprerett4, $nrorginclusao, $nrorgultatu,
        $cdoperador, $cdoperinclusao, $cdoperultatu, $dtinclusao, $dtultatu
    ) {
        $this->setNrorg($nrorg);
        $this->setCdfilial($cdfilial);
        $this->setCdservfili($cdservfili);
        $this->setDtprevreti($dtprevreti);
        $this->setCdtipoprat($cdtipoprat);
        $this->setCdprato($cdprato);
        $this->setCdfilauxprat($cdfilauxprat);
        $this->setIdprevreti($idprevreti);
        if (empty($idprevtpprat) === false) {
            $this->setIdprevtpprat($idprevtpprat);
        }
        //
        $this->setNrrequextr($nrrequextr);
        $this->setNrprprevreti($nrprprevreti);
        $this->setCdproduto($cdproduto);
        $this->setDtlimitereti($dtlimitereti);
        $this->setHrlimitereti($hrlimitereti);
        $this->setQtprevreti($qtprevreti);
        $this->setQtprerett1($qtprerett1);
        $this->setQtprerett2($qtprerett2);
        $this->setQtprerett3($qtprerett3);
        $this->setQtprerett4($qtprerett4);
        //
        $this->setNrorginclusao($nrorginclusao);
        $this->setNrorgultatu($nrorgultatu);
        $this->setCdoperador($cdoperador);
        $this->setCdoperinclusao($cdoperinclusao);
        $this->setCdoperultatu($cdoperultatu);
        $this->setDtinclusao($dtinclusao);
        $this->setDtultatu($dtultatu);
        //
        $this->setIdativo('S');
        //
        $this->persist();
    }

    public function atualizaRegistroPrevreti(
        $dtlimitereti, $hrlimitereti, $qtprevreti, $qtprerett1, $qtprerett2,
        $qtprerett3, $qtprerett4, $nrorgultatu, $cdoperultatu, $dtultatu
    ) {
        $this->setDtlimitereti($dtlimitereti);
        $this->setHrlimitereti($hrlimitereti);
        $this->setQtprevreti($qtprevreti);
        //$this->setQtprerett1($qtprerett1);
        //$this->setQtprerett2($qtprerett2);
        //$this->setQtprerett3($qtprerett3);
        //$this->setQtprerett4($qtprerett4);
        //
        $this->setNrorgultatu($nrorgultatu);
        $this->setCdoperultatu($cdoperultatu);
        $this->setDtultatu($dtultatu);
        //
        $this->setIdativo('S');
        //
        $this->persist();
    }

    public static function deletaRegistroPrevreti($reg) {
        if ($reg instanceof self) {
            $reg->delete();
        }
    }

    public function atualizaQtpreretPrevreti($counter, $qtpreret) {
        switch ($counter) {
        case 1: $this->setQtprerett1($qtpreret);
            break;
        case 2: $this->setQtprerett2($qtpreret);
            break;
        case 3: $this->setQtprerett3($qtpreret);
            break;
        case 4: $this->setQtprerett4($qtpreret);
            break;
        default: return 0;
        }
        //
        $this->persist();
    }
}