/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VOO                                                      */
/* Tabela : VOO                                                               */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_VOO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_VOO
GO

CREATE TRIGGER DTULTATU_VOO
ON VOO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'VOO', null, 'CDFILIAL='+ CDFILIAL+ ';'+
                                  'CDCIA='+ CDCIA + ';'+
                                  'NRVOO='+ NRVOO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE VOO
      SET DTULTATUVOO = GETDATE()
      FROM INSERTED;
   END;
END;
GO

